Ruby - Bug #11512

DelegateClass.#public_{instance_}methods are returning difference values.
09/07/2015 05:00 PM - kachick (Kenichi Kamiya)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.2.3p173 (2015-08-18 revision Backport: 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2:
51636) [x86_64-linux] UNKNOWN

Description
Is this intended behavior?

A patch is PR#926(https:/github.com/ruby/ruby/pull/926)

require 'delegate'

class Parent
def parent_public; end

protected

def parent_protected; end
end

class Child < Parent
end

class DelegatorChild < DelegateClass (Parent)
end

class Parent
def parent_public_added; end

protected

def parent_protected_added; end

end

ignores = Object.public_instance_methods | Delegator.public_instance_methods
p(Child.public_instance_methods - ignores) #=> [:parent_public, :parent_public_add
ed]

p(Child.new.public_methods - ignores) #=> [:parent_public, :parent_public_add
ed]

p (DelegatorChild.public_instance_methods - ignores) #=> got: [:parent_public], expected: [:

parent_public, :parent_public_added]
p(DelegatorChild.new (Parent.new) .public_methods - ignores) #=> got: [:parent_public, :parent_publi
c_added, :parent_protected]], expected: [:parent_public, :parent_public_added]

Associated revisions

Revision e8c710b11a02c6ab82b358fc671a14f378cb1974 - 05/31/2019 01:34 AM - jeremyevans (Jeremy Evans)
Fix visibility of some methods when using DelegateClass
Public instance methods added to a delegated class after the

creation of the delegate class were not returned by the
public_instance_methods class method of the delegate class.

Protected instance methods in the delegated class when the

delegate class is created were returned by the public_methods
instance method of the delegate class.
https://github.com/ruby/ruby/pull/926

Patch mostly from Kenichi Kamiya kachick1@gmail.com in
GitHub pull request 926. Minor changes to get it to apply,
and to fix tests after applying by me.

Fixes [Bug #11512]

Revision e8¢c710b11a02c6ab82b358fc671a14f378cb1974 - 05/31/2019 01:34 AM - jeremyevans (Jeremy Evans)

Fix visibility of some methods when using DelegateClass

Public instance methods added to a delegated class after the
creation of the delegate class were not returned by the
public_instance_methods class method of the delegate class.

Protected instance methods in the delegated class when the
delegate class is created were returned by the public_methods
instance method of the delegate class.

Patch mostly from Kenichi Kamiya kachick1@gmail.com in
GitHub pull request 926. Minor changes to get it to apply,
and to fix tests after applying by me.

Fixes [Bug #11512]

Revision e8¢c710b1 - 05/31/2019 01:34 AM - jeremyevans (Jeremy Evans)

Fix visibility of some methods when using DelegateClass

Public instance methods added to a delegated class after the
creation of the delegate class were not returned by the
public_instance_methods class method of the delegate class.

Protected instance methods in the delegated class when the
delegate class is created were returned by the public_methods
instance method of the delegate class.

Patch mostly from Kenichi Kamiya kachick1@gmail.com in
GitHub pull request 926. Minor changes to get it to apply,
and to fix tests after applying by me.

Fixes [Bug #11512]

History

#1 - 05/24/2019 05:02 AM - jeremyevans0 (Jeremy Evans)
- File fix-delegate-class-method-visibility.patch added

This appears to still be a bug. The patch needed a little manual help to apply, and the tests needed to be updated, but after those changes, all tests
passed. Attached is an updated patch. I'll try to commit it next week unless | hear objections.

#2 - 05/31/2019 01:41 AM - jeremyevans (Jeremy Evans)
- Status changed from Open to Closed

Applied in changeset git|e8c710b11a02c6ab82b358fc671a14f378cb1974.

Fix visibility of some methods when using DelegateClass

Public instance methods added to a delegated class after the
creation of the delegate class were not returned by the
public_instance_methods class method of the delegate class.

Protected instance methods in the delegated class when the
delegate class is created were returned by the public_methods
instance method of the delegate class.

Patch mostly from Kenichi Kamiya kachick1@gmail.com in
GitHub pull request 926. Minor changes to get it to apply,
and to fix tests after applying by me.

Fixes [Bug #11512]

07/16/2025 2/3


mailto:kachick1@gmail.com
mailto:kachick1@gmail.com
mailto:kachick1@gmail.com
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/e8c710b11a02c6ab82b358fc671a14f378cb1974
mailto:kachick1@gmail.com
https://bugs.ruby-lang.org/issues/11512

Files

fix-delegate-class-method-visibility.patch 3.69 KB 05/24/2019 jeremyevansO0 (Jeremy Evans)
